import { BranchNode, BranchNodeDefinition } from './nodes/Branch';
export declare class DecisionTree extends BranchNode {
    fallbackValue?: any;
    constructor(definition: DecisionTreeDefinition);
    toJSON(): {
        fallbackValue: any;
        children?: import("./nodes").NodeDefinition[];
        condition: import("./Rule").RuleDefinition;
    };
    evaluate(data: any): any;
    getLeaves(): any[];
}
export interface DecisionTreeDefinition extends BranchNodeDefinition {
    /**
     * This option makes it so that the tree is initialized with a "fallback"
     * child. The motivation behind this is to ensure that, once the tree's
     * initial condition is met, we'll _always_ return a value. This is helpful
     * for use-cases where you want to make sure that things don't fall through
     * the cracks.
     */
    fallbackValue?: any;
}
