"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = __importDefault(require("lodash"));
var Branch_1 = require("./nodes/Branch");
var DecisionTree = /** @class */ (function (_super) {
    __extends(DecisionTree, _super);
    function DecisionTree(definition) {
        var _this = 
        // Pass `false` for the second parameter (`parent`) since this is the root node.
        _super.call(this, definition, false) || this;
        _this.fallbackValue = definition.fallbackValue;
        return _this;
    }
    DecisionTree.prototype.toJSON = function () {
        return __assign({}, _super.prototype.toJSON.call(this), { fallbackValue: this.fallbackValue });
    };
    DecisionTree.prototype.evaluate = function (data) {
        // Get the raw value obtained from calling `evaluate` on our superclass.
        var returnedVal = _super.prototype.evaluate.call(this, data);
        if (!returnedVal && this.fallbackValue) {
            // If we have a `fallbackValue` and our initial condition is met, return
            // the `fallbackValue`.
            if (this.condition.evaluate(data))
                return this.fallbackValue;
        }
        return returnedVal;
    };
    DecisionTree.prototype.getLeaves = function () {
        var leaves = [];
        var recurse = function (node) {
            if (node.isLeafNode()) {
                leaves.push(node);
            }
            else {
                lodash_1.default.forEach(node.getChildren(), recurse);
            }
        };
        lodash_1.default.forEach(this.children, recurse);
        return leaves;
    };
    return DecisionTree;
}(Branch_1.BranchNode));
exports.DecisionTree = DecisionTree;
