import { Operator } from './Operator';
export declare type RuleDefinition = CompoundRuleDefinition | SingleRuleDefinition;
export interface CompoundRuleDefinition {
    and?: RuleDefinition[];
    or?: RuleDefinition[];
}
export interface SingleRuleDefinition {
    path: string;
    operator: Operator;
    value?: any;
}
export declare class Rule {
    private readonly and?;
    private readonly or?;
    private readonly path?;
    private readonly operator?;
    private readonly value?;
    readonly isCompoundRule?: boolean;
    constructor(definition: RuleDefinition);
    toJSON(): RuleDefinition;
    /**
     * Evaluates a data object using its configured `path`, `operator`, and
     * `value` properties. Returns a boolean.
     */
    evaluate(data: any): boolean;
    private isNil;
    private equals;
    private contains;
    private in;
    private greaterThan;
    private greaterThanOrEqualTo;
    private lessThan;
    private lessThanOrEqualTo;
    private containsSubstring;
}
