"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = __importDefault(require("lodash"));
var Rule_1 = require("../Rule");
/**
 * An abstract node class that is extended by the different types of nodes.
 */
var Node = /** @class */ (function () {
    /**
     * `parent` is `false` when the node being considered is the root node.
     */
    function Node(_a, parent) {
        var condition = _a.condition;
        this.parent = parent;
        this.condition = new Rule_1.Rule(condition);
    }
    Node.prototype.getParent = function () {
        return this.parent;
    };
    Node.prototype.isLeafNode = function () {
        return lodash_1.default.has(this, 'value');
    };
    return Node;
}());
exports.Node = Node;
