import { CommonNodeDefinition, Node } from './Abstract';
import { LeafNode, LeafNodeDefinition } from './Leaf';
export declare class BranchNode extends Node {
    protected readonly children: (LeafNode | BranchNode)[];
    constructor({ condition, children }: BranchNodeDefinition, parent: Node | false);
    addChild(definition: LeafNodeDefinition | BranchNodeDefinition): BranchNode | LeafNode;
    evaluate(data: any): any;
    getChildren(): (BranchNode | LeafNode)[];
    toJSON(): BranchNodeDefinition;
    private createChild;
}
/**
 * Branch nodes have `children` but no `value`.
 */
export interface BranchNodeDefinition extends CommonNodeDefinition {
    children?: NodeDefinition[];
}
export declare type NodeDefinition = BranchNodeDefinition | LeafNodeDefinition;
