"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = __importDefault(require("lodash"));
var Abstract_1 = require("./Abstract");
var Leaf_1 = require("./Leaf");
var BranchNode = /** @class */ (function (_super) {
    __extends(BranchNode, _super);
    function BranchNode(_a, parent) {
        var condition = _a.condition, children = _a.children;
        var _this = _super.call(this, { condition: condition }, parent) || this;
        _this.children = [];
        _this.children = lodash_1.default.map(children, function (child) { return _this.createChild(child); });
        return _this;
    }
    BranchNode.prototype.addChild = function (definition) {
        var child = this.createChild(definition);
        this.children.push(child);
        return child;
    };
    BranchNode.prototype.evaluate = function (data) {
        if (this.condition.evaluate(data)) {
            for (var _i = 0, _a = this.children; _i < _a.length; _i++) {
                var child = _a[_i];
                var val = child.evaluate(data);
                if (val)
                    return val;
            }
        }
    };
    BranchNode.prototype.getChildren = function () {
        return this.children;
    };
    BranchNode.prototype.toJSON = function () {
        return {
            condition: this.condition.toJSON(),
            children: lodash_1.default.invokeMap(this.children, 'toJSON'),
        };
    };
    BranchNode.prototype.createChild = function (definition) {
        return Leaf_1.isLeafNodeDefinition(definition)
            ? new Leaf_1.LeafNode(definition, this)
            : new BranchNode(definition, this);
    };
    return BranchNode;
}(Abstract_1.Node));
exports.BranchNode = BranchNode;
