import { CommonNodeDefinition, Node } from './Abstract';
import { NodeDefinition } from './Branch';
export declare class LeafNode extends Node {
    private readonly value;
    constructor(definition: LeafNodeDefinition, parent: Node);
    readonly isLeaf: boolean;
    evaluate(data: any): any;
    toJSON(): LeafNodeDefinition;
}
/**
 * Leaf nodes have a `value` but no `children`.
 */
export interface LeafNodeDefinition extends CommonNodeDefinition {
    value: any;
}
export declare function isLeafNodeDefinition(definition: NodeDefinition): definition is LeafNodeDefinition;
