"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = __importDefault(require("lodash"));
var Abstract_1 = require("./Abstract");
var LeafNode = /** @class */ (function (_super) {
    __extends(LeafNode, _super);
    function LeafNode(definition, parent) {
        var _this = _super.call(this, definition, parent) || this;
        _this.value = definition.value;
        return _this;
    }
    Object.defineProperty(LeafNode.prototype, "isLeaf", {
        get: function () {
            return true;
        },
        enumerable: true,
        configurable: true
    });
    LeafNode.prototype.evaluate = function (data) {
        if (this.condition.evaluate(data))
            return this.value;
    };
    LeafNode.prototype.toJSON = function () {
        return { condition: this.condition.toJSON(), value: this.value };
    };
    return LeafNode;
}(Abstract_1.Node));
exports.LeafNode = LeafNode;
function isLeafNodeDefinition(definition) {
    return lodash_1.default.has(definition, 'value');
}
exports.isLeafNodeDefinition = isLeafNodeDefinition;
